import { adapt2Runtime } from '../core/adapter';
import { RuntimeDataSourceItem } from '../core/RuntimeDataSourceItem';
import { reloadDataSourceFactory } from '../core/reloadDataSourceFactory';
import { getRequestHandler } from '../helpers';
/**
 * @param dataSource
 * @param context
 * @param extraConfig: { requestHandlersMap }
 */
export default (function (dataSource, context, extraConfig) {
    if (extraConfig === void 0) { extraConfig = { requestHandlersMap: {} }; }
    var requestHandlersMap = extraConfig.requestHandlersMap;
    var runtimeDataSource = adapt2Runtime(dataSource, context);
    var dataSourceMap = runtimeDataSource.list.reduce(function (prev, current) {
        prev[current.id] = new RuntimeDataSourceItem(current, getRequestHandler(current, requestHandlersMap), context);
        return prev;
    }, {});
    return {
        dataSourceMap: dataSourceMap,
        reloadDataSource: reloadDataSourceFactory(runtimeDataSource, dataSourceMap, runtimeDataSource.dataHandler),
    };
});
